/* manpar - parameters for time-domain model with sharp bm tuning */

#include <stdio.h>
#include "tdmdef.h"
#include "cparam.h"
#include "ctdmio.h"
#include "cdata.h"

tdmpar()
{
   pa_.m = 1;
   pa_.n = 256;
   pa_.xl = 3.55;
   pa_.yh = 0.1;
   pa_.rho = 1.0;
   pa_.k1o = 8.265e7;
   pa_.r1o = 406.5;
   pa_.m1o = 0.0006105;
   pa_.k1e = -2.57;
   pa_.r1e = -1.29;
   pa_.m1e =  0.29;
   pa_.r1c = 80.0;
   pa_.k2o = -5.00e8;
   pa_.r2o = -3670.0;
   pa_.m2o = -0.0739;
   pa_.k2e =  0.00;
   pa_.r2e =  1.86;
   pa_.m2e =  2.86;
   pa_.k3o = 2.00e8;
   pa_.r3o = 0.0;
   pa_.k3e = -1.143;
   pa_.r3e = 0.0;
   pa_.xhel = 0.05;
   pa_.rhel = 20.0;
   pa_.couplr = TRUE;
   pa_.midear = TRUE;
   pa_.basacc = TRUE;
   pa_.apxacc = TRUE;
   pa_.kst = 5e5;
   pa_.rst = 40.0;
   pa_.mst = 5e-3;
   pa_.ast = 0.01;
   pa_.kma = 4e5;
   pa_.rma = 60.0;
   pa_.mma = 10e-3;
   pa_.ama = 0.35;
   pa_.kim = 4e7;
   pa_.rim = 400.0;
   pa_.gmel = 0.5;
   pa_.ked = 3.1e4;
   pa_.red = 3.2;
   pa_.med = 0.14e-3;
   pa_.aed = 0.05;
   pa_.kcp = 2.2e3;
   pa_.rcp = 0.1;
   pa_.mcp = 0.22e-3;
   pa_.acp = 0.071;
   pa_.kdi = 7.7e6;
   pa_.rdi = 100.0;
   pa_.mdi = 5.70e-2;
   pa_.adi = 2.5;
   pa_.bl  = 5.4e6;
   pa_.rvc = 200.0;
   pa_.rfz = 1.0;
   pa_.ntsgat = 0.0;
   pa_.dt = 2e-6;
   pa_.ifrmt = 1;
   pa_.itsc = 0;
   pa_.icycl = 0;
   pa_.itsw = 0;
   pa_.itsf = 0;
   pa_.ntsc = 500;
   pa_.ncycl = 1;
   pa_.ntsw = 100;
   pa_.ntsf = 1;
   pa_.isv[0] = 1;
   pa_.isv[1] = 61;
   pa_.isv[2] = 121;
   pa_.isv[3] = 181;
   pa_.isv[4] = 241;
   pa_.ipl = 0;
   pa_.irl = 0;

   dbgflg[0] = FALSE;
   dbgflg[1] = FALSE;
   dbgflg[2] = FALSE;
   dbgflg[3] = FALSE;
}
