; dm1
; Averages for measurements of cochlear input impedance in cat,
; compared with model input impedance.
;
; part a:
;   x = frequency (kHz)
;   y = magnitude of Zc (1e6 acoustic ohms)
;
header=0 : clip=y : yhor=y
annsiz=-.14 : labsiz=-.14 : msgsiz=-.14 : sizfac=4
newframe
grid=0
xllc=2 : xlen=5 : xcycle=3 : xmin=0.02 : xmax=20.0 : xanskp=-1
yllc=3.5 : ylen=3 : ycycle=2 : ymin=.1 : ymax=10 : yanskp=0
;
pltype=lines only
lintyp=6
include ../datman/dm1a.inc
plot
lintyp=0
include dm1a.dat
plot
;
; part b:
;   x = frequency (kHz)
;   y = phase (degrees)
;
newframe
grid=0
xllc=2 : xlen=5 : xcycle=3 : xmin=0.02 : xmax=20.0 : xanskp=0
yllc=1 : ylen=2 : yint=2.2 : ycycle=0 : ymin=-90 : ymax= 90
;
pltype=lines only
lintyp=6
include ../datman/dm1b.inc
plot
lintyp=0
include dm1b.dat
plot
;
; labels
;
newframe
axlwt=0 : annlwt = 0 : lablwt = 0
xllc=0 : yllc=0 : xlen=0 : ylen=0

mhal=cen : msgangle=90 : msgsiz=-.15
0.9  4.25 "cochlear input impedance";
msgsiz=-.14
1.4  5.0  "|Z'[c]| (10{6} acoustic ohms)"
msgsiz=-.14
1.4  2.0  "phase (degrees)"
msgangle=0 : msgsiz=-.14
4.0  0.4  "frequency (kHz)"
mhal=0 : msgsiz=-.13
2.15 3.7  "(a)"
2.15 1.2  "(b)"
3.2  3.9  "|_6| Lynch et al (1982)"
3.2  4.2  "|_0| model"

